;;; CoAX Binni Process Models - I-DEEL
;;; Author: Jeff Dalton and Austin Tate
;;; Updated: 30-Jun-2001 09:52
;;; Copyright: (c) 2001, AIAI, University of Edinburgh

(refinement avoid_location (avoid ?object ?location)
   (nodes
     (1 (locate ?object ?location ?precise-location))
     (2 (alter_plan_to_avoid ?precise-location))
     (3 (deconflict_plans))
     (4 (establish time-to-cancel-mission))
     (5 (report I-LEED ground-activity))
   )
   (orderings (1 2 3))
)

(refinement avoid_by_altering_timing (avoid ?object ?location)
   (nodes
     (1 (alter_timing))
     (2 (deconflict_plans))
   )
   (orderings (1 2))
)

(refinement MBP_Ops (establish time-to-cancel-mission)
   (nodes
     (1 (query MBP_Ops ?tot ?commit))
     (2 (report I-LEED time-to-cancel-mission ?tot ?commit))
   )
   (orderings (1 2))
)

(refinement use_secondary_targets (alter_plan_to_avoid ?location)
   (issues
       (issue (note "some primaries not targeted"))
   )
   (nodes
     (1 (select_secondary_targets_to_avoid ?location))
   )
)

;;; Definition of some primitives to help in domain model management

(refinement ask_intel (locate ?object ?location ?result)
   ; primitive
)

(refinement ask_observers (locate ?object ?location ?result)
   ; primitive
)

(refinement query_MBP_Ops (query MBP_Ops ?x ?y)
   ; primitive
)

;;; Schemas for demos

(refinement sop_do
               (do ?this)
  (nodes
    (1 (do ?this part-1))
    (2 (do ?this part-2)))
  (orderings
    ))


;;; End
